#! /bin/sh -f

######################################################################
# IBM Confidential
# OCO Source Materials
# Rational ClearCase and ClearQuest
# (C) Copyright IBM Corp. 2007, 2010. All Rights Reserved.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
######################################################################

#
# The purpose of this script is to wrap the cqrpc server's executable so that
# required setup can be done for that executable. The script assumes it is started
# in the CWD where the RPC server is installed.
#

#
# Must initialize ClearQuest because the CCRPC server depends on parts of CQ also.
#
CQSCRIPT=/opt/rational/clearquest/cq_setup.sh
if [ -f $CQSCRIPT ]
then
  echo Initializing CQ environment
  . $CQSCRIPT
else
  echo Skipping Initializing CQ environment because CQ not installed.
fi

#
# Set path to include CWD.
#
PATH=.:$PATH
export PATH;

#
# Set LD_LIBRARY_PATH (or platform equivalent) to include all the 
# other libraries that are in this CWD.
#
WHICHARCH=`uname -s`
ARCH=`expr "$WHICHARCH" : '\(..\)'`
ARCH="`echo $ARCH | tr '[:lower:]' '[:upper:]'`"
if [ "$ARCH" = "HP" ]
then
  SHLIB_PATH=.:$SHLIB_PATH
  export SHLIB_PATH;
  echo SHLIB_PATH set to $SHLIB_PATH
  
  # increase the open file number and data segment of ccrpc.
  # it is a defense strategy for the system which limits the open files and data segment 
  # to a very low level.
  ulimit -n 1048576
  ulimit -d 1048576
else
  ARCH=`expr "$WHICHARCH" : '\(...\)'`
  ARCH="`echo $ARCH | tr '[:lower:]' '[:upper:]'`"
  
  # increase the open file number and data segment of ccrpc.
  # it is a defense strategy for the system which limits the open files and data segment 
  # to a very low level.
  if [ "$ARCH" = "AIX" -o "$ARCH" = "SUN" ]
  then
	ulimit -n unlimited
	ulimit -d unlimited
  else
	ulimit -n 1048576
	ulimit -d unlimited
  fi
  
  if [ "$ARCH" = "AIX" ]
  then
    LIBPATH=.:$LIBPATH
    export LIBPATH;
    echo LIBPATH set to $LIBPATH
  else
    LD_LIBRARY_PATH=.:$LD_LIBRARY_PATH
    export LD_LIBRARY_PATH;
    echo LD_LIBRARY_PATH set to $LD_LIBRARY_PATH
  fi
fi

#
# Pass all command line args to this next exec. Exec is used here so that
# we replace this (shell) process with the new process; we don't want both
# processes running at the same time.
#
echo Execing CC RPC server with this command line:
echo ccrpc $*
exec ccrpc $*
